/*
 * See the COPYRIGHT.txt file distributed with this work for information
 * regarding copyright ownership.
 *
 * This software is made available by Red Hat, Inc. under the terms of the
 * Eclipse Public License v1.0 which accompanies this distribution and is
 * available at http://www.eclipse.org/legal/epl-v10.html.
 *
 * See the AUTHORS.txt file in the distribution for a full listing of
 * individual contributors.
 */
package org.jboss.tools.modeshape.rest;

import org.eclipse.osgi.util.NLS;

/**
 * The <code>RestClientI18n</code> class provides localized messages.
 */
public final class RestClientI18n extends NLS {

    public static String addPublishAreaActionText;
    public static String addPublishAreaActionToolTip;
    public static String addPublishAreaDialogErrorsOccurredMsg;
    public static String addPublishAreaDialogMessage;
    public static String addPublishAreaDialogTitle;
    public static String errorMarkingPublishArea;

    public static String unmarkPublishActionText;
    public static String unmarkPublishAreaActionToolTip;
    public static String unmarkPublishAreaDialogErrorsOccurredMsg;
    public static String deletePublishAreaDialogMessage;
    public static String deletePublishAreaDialogTitle;
    public static String errorUnmarkingPublishArea;

    public static String basePublishingActionPublishingWizardErrorMsg;
    public static String basePublishingActionUnpublishingWizardErrorMsg;

    public static String collapseActionToolTip;

    public static String deleteServerActionText;
    public static String deleteServerActionToolTip;

    public static String deleteServerDialogErrorsOccurredMsg;
    public static String deleteServerDialogMultipleServersMsg;
    public static String deleteServerDialogOneServerMsg;
    public static String deleteServerDialogTitle;

    public static String editServerActionText;
    public static String editServerActionToolTip;
    public static String errorDeletingServerRegistryFile;
    public static String errorDialogTitle;
    public static String errorRestoringServerRegistry;
    public static String errorSavingServerRegistry;

    public static String ignoredResourcesPreferencePageDescription;
    public static String ignoredResourcesPreferencePageLabel;
    public static String ignoredResourcesPreferencePageMessage;
    public static String ignoredResourcesPreferencePageTitle;

    public static String missingImage;

    public static String missingServerPasswordDialogMsg;
    public static String missingServerPasswordDialogTitle;

    public static String newIgnoredResourceDialogLabel;
    public static String newIgnoredResourceDialogTitle;

    public static String newItemDialogValueExists;

    public static String newServerActionText;
    public static String newServerActionToolTip;

    public static String publishedLocationsDialogCopyUrlButton;
    public static String publishedLocationsDialogCopyUrlButtonToolTip;
    public static String publishedLocationsDialogFileUrlColumnHeader;
    public static String publishedLocationsDialogMsg;
    public static String publishedLocationsDialogRepositoryColumnHeader;
    public static String publishedLocationsDialogServerUrlColumnHeader;
    public static String publishedLocationsDialogTitle;
    public static String publishedLocationsDialogUserColumnHeader;
    public static String publishedLocationsDialogWorkspaceColumnHeader;

    public static String publishedResourcePropertyErrorMsg;

    public static String publishingConsoleName;
    public static String publishingConsoleProblemMsg;
    public static String publishingConsoleProblemCreatingHyperlinkMsg;
    public static String publishingConsoleFilePathNotFoundMsg;

    public static String preferenceDefaultScopeNotFound;
    public static String preferenceFileNotFound;
    public static String preferenceNotFound;

    public static String preferencePageDescription;
    public static String preferencePageEnableVersioningEditor;
    public static String preferencePageEnableVersioningEditorToolTip;
    public static String preferencePageMessage;
    public static String preferencePageTitle;

    public static String propertiesBundleLoadErrorMsg;

    public static String publishJobCanceled;
    public static String publishJobDurationMsg;
    public static String publishJobDurationNoHoursMsg;
    public static String publishJobDurationNoHoursNoMinutesMsg;
    public static String publishJobDurationShortMsg;
    public static String publishJobPublish;
    public static String publishJobPublishCanceledMsg;
    public static String publishJobPublishFile;
    public static String publishJobPublishFileFailed;
    public static String publishJobPublishFileInfo;
    public static String publishJobPublishFileWarning;
    public static String publishJobPublishFinishedMsg;
    public static String publishJobPublishName;
    public static String publishJobPublishTaskName;
    public static String publishJobUnexpectedErrorMsg;
    public static String publishJobUnpublish;
    public static String publishJobUnpublishCanceledMsg;
    public static String publishJobUnpublishFile;
    public static String publishJobUnpublishFileFailed;
    public static String publishJobUnpublishFileInfo;
    public static String publishJobUnpublishFileWarning;
    public static String publishJobUnpublishFinishedMsg;
    public static String publishJobUnpublishName;
    public static String publishJobUnpublishTaskName;

    public static String publishPagePublishTitle;
    public static String publishPageIncludeProjectCheckBox;
    public static String publishPageIncludeProjectCheckBoxToolTip;
    public static String publishPageLocationGroupTitle;
    public static String publishPageMissingRepositoryStatusMsg;
    public static String publishPageMissingPublishAreaStatusMsg;
    public static String publishPageMissingServerStatusMsg;
    public static String publishPageMissingWorkspaceStatusMsg;
    public static String publishPageNewServerButton;
    public static String publishPageNoAvailableRepositoriesStatusMsg;
    public static String publishPageNoAvailableServersStatusMsg;
    public static String publishPageNoAvailableWorkspacesStatusMsg;
    public static String publishPageNoResourcesToPublishStatusMsg;
    public static String publishPageNoResourcesToUnpublishStatusMsg;
    public static String publishPageOpenPreferencePageLink;
    public static String publishPagePublishOkStatusMsg;
    public static String publishPagePublishResourcesLabel;
    public static String publishPageRecurseCheckBox;
    public static String publishPageRecurseCheckBoxToolTip;
    public static String publishPageRecurseProcessingErrorMsg;
    public static String publishPageRepositoryLabel;
    public static String publishPageRepositoryToolTip;
    public static String publishPageServerLabel;
    public static String publishPageServerToolTip;
    public static String publishPageUnableToObtainWorkspaceAreas;
    public static String publishPageUnpublishOkStatusMsg;
    public static String publishPageUnpublishResourcesLabel;
    public static String publishPageUnpublishTitle;
    public static String publishPageVersionCheckBox;
    public static String publishPageVersionCheckBoxToolTip;
    public static String publishPageWorkspaceLabel;
    public static String publishPageWorkspacePublishToolTip;
    public static String publishPageWorkspaceUnpublishToolTip;
    public static String publishPageWorkspaceAreaLabel;
    public static String publishPageWorkspaceAreaToolTip;
    public static String publishPageFinishedErrorMsg;

    public static String publishWizardPublishErrorMsg;
    public static String publishWizardPublishTitle;
    public static String publishWizardUnpublishTitle;
    public static String publishWizardUnpublishErrorMsg;

    public static String reconnectJobTaskName;

    public static String requestDialogTitle;
    public static String runningRepositoriesQueryMsg;
    public static String runningServerRequestErrorMsg;
    public static String runningServerRequestErrorDialogMsg;
    public static String runningServerRequestErrorDialogTitle;
    public static String runningServerRequestNewPasswordDialogMsg;
    public static String runningServerRequestNewPasswordDialogTitle;
    public static String runningWorkspacesQueryMsg;

    public static String serverEmptyUrlMsg;
    public static String serverEmptyUserMsg;
    public static String serverExistsMsg;
    public static String serverInvalidUrlMsg;
    public static String serverInvalidUrlHostMsg;
    public static String serverInvalidUrlPortMsg;

    public static String serverManagerConnectionEstablishedMsg;
    public static String serverManagerConnectionFailedMsg;
    public static String serverManagerGetRepositoriesExceptionMsg;
    public static String serverManagerGetWorkspacesExceptionMsg;
    public static String serverManagerRegistryAddUnexpectedError;
    public static String serverManagerRegistryListenerError;
    public static String serverManagerRegistryListenerErrorsOccurred;
    public static String serverManagerRegistryRemoveUnexpectedError;
    public static String serverManagerRegistryUpdateAddError;
    public static String serverManagerRegistryUpdateRemoveError;
    public static String serverManagerUnregisteredServer;

    public static String serverPageAuthenticationGroupTitle;
    public static String serverPageInvalidServerProperties;
    public static String serverPageOkStatusMsg;
    public static String serverPagePasswordLabel;
    public static String serverPagePasswordToolTip;
    public static String serverPageSavePasswordButton;
    public static String serverPageSavePasswordLabel;
    public static String serverPageSavePasswordToolTip;
    public static String serverPageTestConnectionLabel;
    public static String serverPageTestConnectionButton;
    public static String serverPageTestConnectionButtonToolTip;
    public static String serverPageTestConnectionDialogFailureMsg;
    public static String serverPageTestConnectionDialogTitle;
    public static String serverPageTestConnectionDialogSuccessMsg;
    public static String serverPageTitle;
    public static String serverPageUrlLabel;
    public static String serverPageUrlTemplateLabel;
    public static String serverPageUrlToolTip;
    public static String serverPageUserLabel;
    public static String serverPageUserToolTip;

    public static String serverReconnectActionText;
    public static String serverReconnectActionToolTip;

    public static String serverValidationError;

    public static String serverViewToolTip;

    public static String serverWizardEditServerErrorMsg;
    public static String serverWizardEditServerTitle;
    public static String serverWizardNewServerErrorMsg;
    public static String serverWizardNewServerTitle;

    public static String showPublishedLocationsErrorMsg;

    public static String testServerActionText;
    public static String testServerActionToolTip;

    public static String workspaceAreaDescription;
    public static String workspacePath;

    static {
        NLS.initializeMessages("org.jboss.tools.modeshape.rest.RestClientI18n", RestClientI18n.class); //$NON-NLS-1$
    }

}
